datablock DebrisData(dildogunShellDebris)
{
	shapeFile = "./blob.dts";
	lifetime = 4.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.7;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 5;
};

datablock AudioProfile(dildogunSound)
{
   filename    = "./splat.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(dildogunHitSound)
{
   filename    = "./splathit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(dildogunFlashParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./dildogunflash.png";
	spinSpeed		= 15.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.0 0.0 0.0";
	colors[1]     = "0.0 0.0 0.0 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 5.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(dildogunFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "dildogunFlashParticle";

   uiName = "Dildo Gun Muzzle Flash";
};

datablock ParticleData(dildogunSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 625;
	lifetimeVarianceMS   = 36;
	textureName          = "./dildogunflash.png";
	spinSpeed		= 20.0;
	spinRandomMin		= -400.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(dildogunSmokeEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1.5;
   velocityVariance = 1.2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "dildogunSmokeParticle";

   uiName = "Dildo Gun Muzzle Smoke";
};


datablock ParticleData(dildogunExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "./dildogunflash.png";
	spinSpeed		= 1.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 1 1 0.5";
	colors[1]     = "1 1 1 0.4";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(dildogunExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "dildogunExplosionParticle";

   useEmitterColors = true;
   uiName = "Dildo Gun bullet Hit Dust";
};


datablock ParticleData(dildogunExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 35;
	textureName          = "./dildogunflash.png";
	spinSpeed		= 5.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 2;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(dildogunExplosionRingEmitter)
{
	lifeTimeMS = 40;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "dildogunExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Dildo Gun Bullet Hit Flash";
};

datablock ExplosionData(dildogunExplosion)
{
   //explosionShape = "";
	soundProfile = dildogunHitSound;

   lifeTimeMS = 150;

   particleEmitter = dildogunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = dildogunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 1;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";
};


AddDamageType("Dildo Gun",   '<bitmap:add-ons/Weapon_DildoGun/CI_dildogun> %1',    '%2 <bitmap:add-ons/Weapon_DildoGun/CI_dildogun> %1',0.2,1);
datablock ProjectileData(dildogunProjectile)
{
   projectileShapeName = "./blob.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::DildoGun;
   radiusDamageType    = $DamageType::DildoGun;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 10;          
   brickExplosionMaxVolumeFloating = 15;  

   impactImpulse	     = 450;
   verticalImpulse	  = 400;
   explosion           = dildogunExplosion;
   particleEmitter     = ""; //unused;

   muzzleVelocity      = 120;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.1;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.6";

   uiName = "Dildo Gun Bullet";
};

datablock ItemData(DildoGunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./dildogun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Dildo Gun";
	iconName = "./icon_dildogun";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	image = dildogunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(dildogunImage)
{
   shapeFile = "./dildogun.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = dildogunProjectile;
   projectileType = Projectile;

	casing = dildogunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;

   armReady = true;

   doColorShift = true;
   colorShiftColor = dildogunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= dildogunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= dildogunSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= dildogunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function dildogunImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}
